#include "tutte.h"

void tutteAlgorithm (multigraph * g,polynom * result){
    int myLoop;

    if(g->getNumEdges()==0){

        result->setComponent(0,0,1);
    }
    else if(g->hasLoop()){
        myLoop = g->getFirstLoop();
        g->removeEdge(myLoop,myLoop);
        tutteAlgorithm(g,result);
        result->multY();
    }
    else if (g->hasBridge()){
        setGraph * myEdge = new setGraph(2);
        g->getFirstBridge(myEdge);
        g->collapseEdge(myEdge->get(0),myEdge->get(1));
        tutteAlgorithm(g,result);
        result->multX();
        myEdge->destroySet();
        delete myEdge;
    }
    else if(!g->hasLoop() && !g->hasBridge() && g->getNumEdges()>0){
        polynom * result2 = new polynom (result->getOrder());
        setGraph * myEdge = new setGraph(2);
        g->getFirstEdge(myEdge);
        multigraph * aux = new multigraph(g->getNumVertex());
        aux->copyGraph(g);
        g->collapseEdge(myEdge->get(0),myEdge->get(1));
        aux->removeEdge(myEdge->get(0),myEdge->get(1));
        tutteAlgorithm(g,result);
        tutteAlgorithm(aux,result2);
        result->addPolynom(result2);
        result2->destroyPolynom();
        delete result2;
        myEdge->destroySet();
        delete myEdge;
        aux->destroyGraph();
        delete aux;
    }

}
